#include <windows.h>
#include <commctrl.h>
#include "04_12_01_resource.h"

#pragma comment(lib,"comctl32.lib")

//---------------------------------------------------------------------
INT_PTR CALLBACK DlgFenetre(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		return TRUE;
	}
	return FALSE;
}

int main()
{
	int ret;
	InitCommonControls();
	ret = DialogBox(0, MAKEINTRESOURCE(IDD_FENETRE), 0, DlgFenetre);
	return 0;
}

/*!F
	J'entame ici un chapitre qui pourrait devenir immense si je m'y penche.
	Car la cration de fentre sous Windows est tellement souple que le nombre d'options possibles est norme.

	Les codes proposs proposeront quelques options, quelques tests  faire dans les commentaires (il faut tout lire si vous tres curieux)
	mais surement pas tout.
	Je proposerai souvent des liens vers la doc, pour que vous voyiez et essayiez les autres options proposes.

	Ce programme comporte 3 fichiers. (avec comme prfixe le numro du paragraphe, mais a n'a pas d'importance)
	simpledialog.c : le fichier main.
	resource.rc    : fichier ressource.
	resource.h     : un .h

	Pour compiler le programme, mettez le .c dans votre projet, ainsi que le .h, comme d'habitude.
	Pour insrer le fichier .rc, cliquez droit sur le projet, faites "ajouter", puis vous trouverez, par type, le fichier .rc

	Notez le include de <commctrl.h>, "commoncontrol", qui sert  faire des fentres de contrle Windows.

	Il sera ncessaire d'inclure la librairie comctl32. (.lib ou .a selon que vous tes sous Visual C++ ou Code::blocks)

	Compilez le, et lancez le. Vous devriez avoir une petite fentre qui s'ouvre, avec juste marqu "plouf" dedans.

	Commenons les explications.

	Regardez le main. 
	Tout d'abord, on appelle une fonction InitCommonControls, qui va initialiser tous les contrles windows pour dessiner les fentres.
	Tel SDL_Init pour SDL, appelez cette fonction si vous faites des fentres Windows.	

	DialogBox.
	Cette fonction prend 4 paramtres :
	- l'Handle de l'exe qui l'appeller. En mettant 0, on dit que la fentre cre n'appartient  personne
	- la ressource  utiliser (voir ci dessous)
	- l'Handle de la fentre mre : si vous vouliez que la fentre soit sous une autre. Ici, non, donc 0.
	- la fonction CALLBACK de la fentre. Il s'agit de la fonction qui sera appele automatiquement lors de l'interraction avec notre fentre.
	
	Vous voyez que c'est la fonction juste au dessus : DlgFenetre

	Nous verrons l'explication de cette fonction juste aprs.

FICHIER RC :
************

	Maintenant, nous allons regarder le fichier ressource, c'est lui qui va dfinir  proprement parler l'allure de la fentre.

	Cliquez sur le fichier rc dans votre projet, au besoin cliquez droit et faites "afficher le code"

	Le fichier contient d'abord deux lignes de include : on inclus Windows, et on inclus notre .h, vous allez vite voir pourquoi.

	La premire ligne est la suivante :

	IDD_FENETRE DIALOG 100, 100, 50, 45

	Elle veut littralement dire : "je cre un DIALOG (donc une fentre de contrle Windows ), 
		d'identifiant IDD_FENETRE,  la position  100,100,   de largeur 50, et de hauteur 45.

	Notez que ces valeurs sont en "dialog unit" et non en pixels.

	Si vous changez ces valeurs, vous mettez la fentre ailleurs, ou changez sa taille.
	Doc : 
	http://msdn.microsoft.com/en-us/library/windows/desktop/aa381002(v=vs.85).aspx

	Avant de continuer, regardez l'identifiant : 
		IDD_FENETRE.

	Vous remarquerez en ouvrant le fichier .h qu'il est dfini ici (avec une valeur  100), et si vous retournez dans le main, vous verrez
	que le deuxime paramtre de DialogBox le rfrence (via la macro MAKEINTRESOURCE qui nous dit finalement qu'on va chercher la ressource)
	C'est donc cet identifiant qui fait le lien entre notre main, et la ressource qu'on voit.

	Il est d'usage de commencer  rfrencer ses identifiants  la valeur 100. Si vous en faites davantage, vous utiliserez 101,102,etc...

	continuons avec les lignes :
	
	STYLE DS_MODALFRAME|WS_VISIBLE|WS_CAPTION|WS_SYSMENU
	CAPTION "Titre"
	FONT 8, "Helv"
	
	qui sont des paramtres  la suite de la premire ligne (on est revenu  la ligne par soucis de propret)

	La doc que j'ai mentionn explique chacun de ces paramtres.

	- Nous avons CAPTION qui est le titre. Facile  comprendre pour le changer.

	- Nous avons STYLE pour dfinir le style de la fentre.
	Il y en a deux types : ceux qui commencent par WS
	http://msdn.microsoft.com/en-us/library/windows/desktop/ms632600(v=vs.85).aspx
	Et ceux qui commencent par DS
	http://msdn.microsoft.com/en-us/library/aa932937.aspx

	On peut allgrement mlanger les deux styles (avec des |) comme il est d'ailleurs fait dans notre exemple.

	Notez que si vous mettez DS_CENTER (essayez), la fentre sera centre au milieu de l'cran. Dans ce cas donc, 
	les paramtres de placement (100,100 dans notre exemple) sont inutiles.

	Notez que si vous enlevez WS_SYSMENU, la croix pour fermer la fentre disparait. (il faudra donc la fermer depuis la barre
	de tches ou killer le processus)

	- nous avons aussi FONT qui permet de choisir la police pour la fentre, avec sa taille.
	Changez donc le 8 en 20 pour voir.

	Vous noterez d'ailleurs que les tailles sont proportionnelles  la taille de la font : la fentre est plus grande et place plus
	loin si vous agrandissez les font : le "dialog unit" dpend de cette valeur.

	Vous pouvez changer de font en changeant de nom (essayez "Arial")
	Et vous pouvez rajouter gras, italic comme ici :
	http://msdn.microsoft.com/en-us/library/windows/desktop/aa381013(v=vs.85).aspx

	Nous y voila. La fentre est dfinie.

	Que met on dedans ?

	Et bien on mettra ce qu'il y a entre BEGIN et END.

	Et ici, une seule chose :

	 LTEXT "Plouf", -1, 10, 10, 30, 40

   On crit "Plouf", on ne lui donne pas d'identifiant (-1),  la position 10,10 dans la fentre, largeur 30 et hauteur 40 pixels
   Et on aligne le texte  gauche (LTEXT). Vous pouvez essayer de l'aligner  droite (RTEXT) ou au centre (CTEXT)
   mais notez que la fentre est en "dialog unit", et non en pixels, donc la zone que vous dcrivez en pixels n'a pas la mme unit.
   Il faudra que je vois un peu mieux a.
   
   Passons.

   Et bien a y'est, nous avons dfini notre fentre.

LA FONCTION CALLBACK :
**********************

   Revenons au main. 

   La fonction DialogBox est bloquante jusqu' ce que la fentre soit dtruite. Et en attendant, chaque interaction avec la fentre 
   appellera un venement, et donc la fonction callback (ou vous traiterez les vnements)
   Si vous cliquez dedans, si vous cliquez sur le bouton de fermeture (la croix), et mme si vous la survoler, la fonction est appele.

   Et c'est la qu'on dira ce qu'on veut faire.

   Regardons la fonction :

   INT_PTR CALLBACK DlgFenetre(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)

   Tout d'abord, la signature de la fonction, vous n'y touchez pas. Quand la fonction est appele, c'est qu'on a un vnement, 
   et tous les paramtres sont remplis.
   Vous les rcuprez ou pas, mais ils sont la.
   Si vous avez fait de la SDL, c'est comme la gestion d'vnement dans SDL.

   Le premier paramtre  voir est le paramtre msg qui sera le type d'vnement.
   Nous switchons en fonction de ce paramtre.

   Il existe plein de paramtres possibles :
   http://msdn.microsoft.com/en-us/library/windows/desktop/ff468922(v=vs.85).aspx

	Ici, nous n'en testerons qu'un seul : WM_CLOSE

	C'est l'vnement qui est appel quand on clique sur la croix.
	Si il se passe cela, on ferme la fentre avec :

	EndDialog(hDlg, 0);

	hDlg est le handle de la fentre, qu'on a dans la fonction.

	Et le 0 est le code de retour souhait, celui qu'on aura dans "ret" dans le main. Changez le pour voir, et regardez ret.

	Voila donc l'ide, le programme se termine donc quand on appuie sur la croix car il passe dans le case qui appelle EndDialog,
	ce qui fait rendre la main  DialogBox
!*/

/*!E
	No explanations yet.
!*/

/*
titre: Cration d'une fentre simple
titreE: Simple customized window.
meta: C;WINAPI;Windows
metaE: C;WINAPI;Windows
desc: Cration d'une fentre simple
descE: Simple customized window.
cle  : DialogBox
linkT: 04_12_01_resource.h
linkT: 04_12_01_resource.rc
parag: 4.12. Cration de fentres  l'aide de fichiers rc.
paragE: 4.12. Creating windows with rc file.
*/
